
# substitute a configuration block in with %-operator
# define the following:
#   VIEWER_URL
#   AJAX_URL
#   EXCEPT_ID

javascript="""
<script language='javascript'>

%s

    function getHTTPObject() 
    {
        var xmlhttp;

    /*@cc_on
      @if (@_jscript_version >= 5)

        try 
        {
            xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
        } catch (e) 
        {
            try 
            {
                xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
            } catch (E) 
            {
                xmlhttp = false;
            }
        }
      
      @else

        xmlhttp = false;

      @end @*/

      if (!xmlhttp && typeof XMLHttpRequest != 'undefined') 
      {
            try 
            {
                xmlhttp = new XMLHttpRequest();
            } catch (e) 
            {
                xmlhttp = false;
            }
      }
      return xmlhttp;
    }

    ajax = getHTTPObject();

    function onResponse()
    {
        if ((ajax.readyState==4) && (ajax.responseText.length>10))
        {
            if (ajax.responseText.toLowerCase().indexOf("<html>")==0)
                document.body.innerHTML = ajax.responseText
            else
                ajax.insertPoint.innerHTML = ajax.responseText
        }
    }
    
    function standardParams()
    {
        var form = document.forms[0]
        return "depth="+form.stackSelector.selectedIndex+"&callables="+form.callables.value+"&hidden="+form.hidden.value
    }

    function setStackDepth()
    {
        document.location = VIEWER_URL+"except_id="+EXCEPT_ID+"&"+standardParams()
    }
    
    function getPythonPath(node)
    {
        var path = node.getElementsByTagName("var")[0].innerHTML
        if (node.parentNode.parentNode.nodeName.toLowerCase()=="ul")
        {
            if (node.parentNode.previousSibling.nodeName.toLowerCase()=="li")
            {
                path = getPythonPath(node.parentNode.previousSibling)+"."+path
            }
        }
        return path
    }
    
    function toggleVisibility(node)
    {
        var i=node.className.indexOf("folded");
        if (i==0)
        {
            node.className="un"+node.className
            if (node.className.indexOf("fetched")<0)
            {
                node.className += " fetched"
                
                var placeHolder = document.createElement("DIV")
                placeHolder.className = "placeholder"
                placeHolder.appendChild( document.createTextNode("fetching data...") )
                var newListItem = document.createElement("LI")
                newListItem.appendChild( placeHolder )
                var newList = document.createElement("UL")
                newList.appendChild(newListItem)
                node.parentNode.insertBefore( newList, node.nextSibling )
                
                py_path = getPythonPath(node)
                
                ajax.insertPoint = newList
                ajax.open("GET", AJAX_URL+"except_id="+EXCEPT_ID+"&"+standardParams()+"&path="+py_path, true);
                ajax.onreadystatechange = onResponse;
                ajax.send(null);                
            }
            else
            {
                node.nextSibling.className=node.nextSibling.className.substring(0,-7)
            }
        }
        else if (i==2)
        {
            node.className=node.className.substring(i)
            node.nextSibling.className+=" hidden"
        }
    }

</script>
"""
